MODULE_NAME='Bose VB-S Demo v1_0 - UI' (DEV dvPanel, DEV vdvDevice)

/////////////////////////////////////////////////////////////
// IN ORDER TO VIEW THIS FILE CORRECTLY,
// PLEASE SET YOUR NETLINX STUDIO EDITOR SETTINGS TO:
// TAB STOP CHARACTERS: 2
// INDENT BEFORE TEXT: 2
/////////////////////////////////////////////////////////////

#IF_NOT_DEFINED __SNAPI_CONST__
#INCLUDE 'SNAPI'
#END_IF

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

// -------------------- COMMUNICATION

CONNECT													= 1;
DISCONNECT											= 2;
RECONNECT											 	= 3;
DEBUG						  							= 4;
COMMUNICATING										= 5;
INITIALIZED											= 6;

// -------------------- CAMERA

CAMERA_PRESET_HOME 							= 21
CAMERA_PRESET_1									= 22;
CAMERA_PRESET_2									= 23;
CAMERA_PRESET_SAVED							= 24;

CAMERA_UP												= 31;
CAMERA_DOWN											= 32;
CAMERA_LEFT											= 33;
CAMERA_RIGHT										= 34;
CAMERA_IN												= 35;
CAMERA_OUT											= 36;
CAMERA_PAN_LEVEL_PRESS				 	= 37;
CAMERA_TILT_LEVEL_PRESS					= 38;
CAMERA_ZOOM_LEVEL_PRESS					= 39;

CAMERA_PAN_LEVEL								= 1;
CAMERA_TILT_LEVEL								= 2;
CAMERA_ZOOM_LEVEL								= 3;

CAMERA_AUTOFRAME_ON							= 41;
CAMERA_AUTOFRAME_OFF						= 42;
CAMERA_AUTOFRAME_TOGGLE					= 43;

// -------------------- AUDIO

AUDIO_LOUDSPEAKER_UP						= 51;
AUDIO_LOUDSPEAKER_DOWN					= 52;
AUDIO_LOUDSPEAKER_MUTE					= 53;
AUDIO_LOUDSPEAKER_LEVEL_PRESS		= 54;
AUDIO_LOUDSPEAKER_LEVEL					= 11;

AUDIO_MIC_MUTE									= 61;
AUDIO_MIC_UNMUTE								= 62;
AUDIO_MIC_MUTE_TOGGLE						= 63;

AUDIO_BLUETOOTH_ENABLE					= 70;
AUDIO_BLUETOOTH_PAIR_ON					= 71;
AUDIO_BLUETOOTH_PAIR_OFF				= 72;
AUDIO_BLUETOOTH_PAIR_TOGGLE			= 73;

// -------------------- MONITORING

MONITOR_DEVICE_NAME							= 81;
MONITOR_DEVICE_SERIAL						= 82;
MONITOR_DEVICE_FW								= 83;
MONITOR_DEVICE_CAMERA						= 84;
MONITOR_DEVICE_CAMERA_PRESET		= 85;

MONITOR_LOCATION_BUILDING				= 91;
MONITOR_LOCATION_FLOOR					= 92;
MONITOR_LOCATION_ROOM						= 93;

//MONITOR_ETHERNET_STATE					= 101;
//MONITOR_ETHERNET_IP							= 102;
//MONITOR_ETHERNET_MAC						= 103;

MONITOR_WIFI_STATE							= 111;
MONITOR_WIFI_IP									= 112;
MONITOR_WIFI_MAC								= 113;

MONITOR_GPI_MUTE_STATUS					= 121;

MONITOR_USB_CONNECTION					= 131;
MONITOR_USB_CALL_ACTIVE					= 132;

MONITOR_BLUETOOTH_CONNECTION		= 141;
MONITOR_BLUETOOTH_STREAM				= 142;

// -------------------- CONFIGURATION

CONFIG_READY										= 151;
CONFIG_REBOOT										= 152;

//CONFIG_HDMI_ENABLE							= 161;
CONFIG_BLUETOOTH_ENABLE					= 162;
CONFIG_BLUETOOTH_BTN_ENABLE			= 163;

// -------------------- FEEDBACK

TL_FEEDBACK 										= 1;
LONG FEEDBACK_TIMES[]						= {300};

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

// -------------------- MENU

VOLATILE INTEGER nMenuBtns[] =
{
	11,	// CAMERA
	12,	// AUDIO
	13,	// MONITORING
	14	// CONFIGURATION
}

VOLATILE CHAR sMenuPopups[][255] = 
{
	'Camera',
	'Audio',
	'Monitoring',
	'Configuration'
}

VOLATILE INTEGER nCurrentMenu;

// -------------------- CAMERA

VOLATILE INTEGER nCurrentCameraPreset;
VOLATILE INTEGER nPanLevelSetIn, nPanLevelCurrentVal;
VOLATILE INTEGER nTiltLevelSetIn, nTiltLevelCurrentVal;
VOLATILE INTEGER nZoomLevelSetIn, nZoomLevelCurrentVal;

// -------------------- AUDIO

VOLATILE INTEGER nVolumeLevelSetIn, nVolumeLevelCurrentVal;

// -------------------- OTHER

VOLATILE INTEGER bDebugEnabled;

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)

// -------------------- UI

DEFINE_FUNCTION DEBUG_PRINT(CHAR sText[])
{
    SEND_STRING 0, "'DEBUG ', sText"
}

DEFINE_FUNCTION SHOW_POPUP(INTEGER nIndex)
{
	nCurrentMenu = nIndex;
	
	IF (nIndex)
		SEND_COMMAND dvPanel, "'@PPN-', sMenuPopups[nIndex]";
	
	ELSE
		SEND_COMMAND dvPanel, "'@PPA-Main'";
}

DEFINE_FUNCTION SEND_TEXT(INTEGER nButton, CHAR sText[])
{
	SEND_COMMAND dvPanel, "'^TXT-', ITOA(nButton), ',0,', sText";
}

DEFINE_FUNCTION UI_BUTTON_ENABLE(INTEGER nButton)
{
	SEND_COMMAND dvPanel, "'^ENA-', ITOA(nButton), ',1'";
}

DEFINE_FUNCTION UI_BUTTON_DISABLE(INTEGER nButton)
{
	SEND_COMMAND dvPanel, "'^ENA-', ITOA(nButton), ',0'";
}

// -------------------- CLEAR

DEFINE_FUNCTION CLEAR()
{
	nPanLevelCurrentVal = 0;
	nTiltLevelCurrentVal = 0;
	nZoomLevelCurrentVal = 0;
	nVolumeLevelCurrentVal = 0;
}

// -------------------- REFRESH

DEFINE_FUNCTION REFRESH_ALL()
{
	REFRESH_PAN();
	REFRESH_TILT();
	REFRESH_ZOOM();
	REFRESH_VOLUME();
}

DEFINE_FUNCTION REFRESH_PAN()
{
	SEND_LEVEL dvPanel, CAMERA_PAN_LEVEL, nPanLevelCurrentVal;
}

DEFINE_FUNCTION REFRESH_TILT()
{
	SEND_LEVEL dvPanel, CAMERA_TILT_LEVEL, nTiltLevelCurrentVal;
}

DEFINE_FUNCTION REFRESH_ZOOM()
{
	SEND_LEVEL dvPanel, CAMERA_ZOOM_LEVEL, nZoomLevelCurrentVal;
}

DEFINE_FUNCTION REFRESH_VOLUME()
{
	SEND_LEVEL dvPanel, AUDIO_LOUDSPEAKER_LEVEL, nVolumeLevelCurrentVal;
}

// -------------------- ENABLE/DISABLE
DEFINE_FUNCTION ENABLE_BLUETOOTH_BUTTONS()
{
	UI_BUTTON_ENABLE(AUDIO_BLUETOOTH_ENABLE);
}

DEFINE_FUNCTION DISABLE_BLUETOOTH_BUTTONS()
{
	UI_BUTTON_DISABLE(AUDIO_BLUETOOTH_ENABLE);
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

TIMELINE_CREATE(TL_FEEDBACK, FEEDBACK_TIMES, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT);

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

// -------------------- PANEL ONLINE

DATA_EVENT[dvPanel]
{
	ONLINE:
	{
		SHOW_POPUP(0);
		
		IF ([vdvDevice, DATA_INITIALIZED])
		{
			SEND_COMMAND vdvDevice,"'?CAMERAPRESET'";
			SEND_COMMAND vdvDevice,"'?NAME'";
			SEND_COMMAND vdvDevice,"'?SERIALNUMBER'";
			SEND_COMMAND vdvDevice,"'?FWVERSION'";
			SEND_COMMAND vdvDevice,"'?CAMERASTATE'";
			SEND_COMMAND vdvDevice,"'?BUILDING'";
			SEND_COMMAND vdvDevice,"'?FLOOR'";
			SEND_COMMAND vdvDevice,"'?ROOM'";
			//SEND_COMMAND vdvDevice,"'?NETWORKSTATE'";
			//SEND_COMMAND vdvDevice,"'?NETWORKADDRESS'";
			//SEND_COMMAND vdvDevice,"'?NETWORKMAC'";
			SEND_COMMAND vdvDevice,"'?WIFISTATE'";
			SEND_COMMAND vdvDevice,"'?WIFIADDRESS'";
			SEND_COMMAND vdvDevice,"'?WIFIMAC'";
		}
	}
}

// -------------------- NAVIGATION

BUTTON_EVENT[dvPanel, nMenuBtns]
{
	PUSH:
	{
		STACK_VAR INTEGER nIndex;
		nIndex = GET_LAST(nMenuBtns);
		
		SHOW_POPUP(nIndex);
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	STACK_VAR INTEGER i;
	
	FOR (i = 1; i <= LENGTH_ARRAY(nMenuBtns); i++)
	{
		[dvPanel, nMenuBtns[i]] = (nCurrentMenu == i);
	}
}

// -------------------- COMMUNICATION

BUTTON_EVENT[dvPanel, CONNECT]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		
		// TBD
	}
}

BUTTON_EVENT[dvPanel, DISCONNECT]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		
		// TBD
	}
}

BUTTON_EVENT[dvPanel, RECONNECT]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		
		SEND_COMMAND vdvDevice,"'REINIT'";
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, COMMUNICATING] = [vdvDevice, DEVICE_COMMUNICATING];
	[dvPanel, INITIALIZED]   = [vdvDevice, DATA_INITIALIZED];
}

// -------------------- DEBUG

BUTTON_EVENT[dvPanel, DEBUG]
{
	PUSH:
	{
		IF (bDebugEnabled)
			SEND_COMMAND vdvDevice,"'DEBUG-1'";
			
		ELSE
			SEND_COMMAND vdvDevice,"'DEBUG-4'";
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, DEBUG] = (bDebugEnabled == TRUE);
}

// -------------------- CAMERA 

// ----- PRESETS

BUTTON_EVENT[dvPanel, CAMERA_PRESET_HOME]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
	}
	RELEASE:
	{
		SEND_COMMAND vdvDevice,"'CAMERAPRESET-1'";
	}
	HOLD[30]:
	{
		SEND_COMMAND vdvDevice,"'CAMERAPRESETSAVE-1'";
	}
}

BUTTON_EVENT[dvPanel, CAMERA_PRESET_1]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
	}
	RELEASE:
	{
		SEND_COMMAND vdvDevice,"'CAMERAPRESET-2'";
	}
	HOLD[30]:
	{
		SEND_COMMAND vdvDevice,"'CAMERAPRESETSAVE-2'";
	}
}

BUTTON_EVENT[dvPanel, CAMERA_PRESET_2]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
	}
	RELEASE:
	{
		SEND_COMMAND vdvDevice,"'CAMERAPRESET-3'";
	}
	HOLD[30]:
	{
		SEND_COMMAND vdvDevice,"'CAMERAPRESETSAVE-3'";
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, CAMERA_PRESET_HOME] = nCurrentCameraPreset = 1;
	[dvPanel, CAMERA_PRESET_1] 		= nCurrentCameraPreset = 2;
	[dvPanel, CAMERA_PRESET_2] 		= nCurrentCameraPreset = 3;
}

// ----- PTZ

BUTTON_EVENT[dvPanel, CAMERA_UP]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		TO[vdvDevice, 132];
	}
}

BUTTON_EVENT[dvPanel, CAMERA_DOWN]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		TO[vdvDevice, 133];
	}
}

LEVEL_EVENT[dvPanel, CAMERA_TILT_LEVEL]
{
	nTiltLevelSetIn = LEVEL.VALUE;
}

BUTTON_EVENT[dvPanel, CAMERA_TILT_LEVEL_PRESS]
{
	RELEASE:
	{
		SEND_LEVEL vdvDevice, 28, nTiltLevelSetIn;
	}
}

BUTTON_EVENT[dvPanel, CAMERA_LEFT]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		TO[vdvDevice, 134];
	}
}

BUTTON_EVENT[dvPanel, CAMERA_RIGHT]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		TO[vdvDevice, 135];
	}
}

LEVEL_EVENT[dvPanel, CAMERA_PAN_LEVEL]
{
	nPanLevelSetIn = LEVEL.VALUE;
}

BUTTON_EVENT[dvPanel, CAMERA_PAN_LEVEL_PRESS]
{
	RELEASE:
	{
		SEND_LEVEL vdvDevice, 27, nPanLevelSetIn;
	}
}

BUTTON_EVENT[dvPanel, CAMERA_IN]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		TO[vdvDevice, 159];
	}
}

BUTTON_EVENT[dvPanel, CAMERA_OUT]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		TO[vdvDevice, 158];
	}
}

LEVEL_EVENT[dvPanel, CAMERA_ZOOM_LEVEL]
{
	nZoomLevelSetIn = LEVEL.VALUE;
}

BUTTON_EVENT[dvPanel, CAMERA_ZOOM_LEVEL_PRESS]
{
	RELEASE:
	{
		SEND_LEVEL vdvDevice, 15, nZoomLevelSetIn;
	}
}

// ----- AUTO FRAME

BUTTON_EVENT[dvPanel, CAMERA_AUTOFRAME_ON]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		PULSE[vdvDevice, 501];
	}
}


BUTTON_EVENT[dvPanel, CAMERA_AUTOFRAME_OFF]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		PULSE[vdvDevice, 502];
	}
}

BUTTON_EVENT[dvPanel, CAMERA_AUTOFRAME_TOGGLE]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		PULSE[vdvDevice, 500];
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, CAMERA_AUTOFRAME_ON] 	=  [vdvDevice, 503];
	[dvPanel, CAMERA_AUTOFRAME_OFF] = ![vdvDevice, 503];
}

// -------------------- AUDIO

// ----- LOUDSPEAKER LEVEL

BUTTON_EVENT[dvPanel, AUDIO_LOUDSPEAKER_UP]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		TO[vdvDevice, 24];
	}
}

BUTTON_EVENT[dvPanel, AUDIO_LOUDSPEAKER_DOWN]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		TO[vdvDevice, 25];
	}
}

LEVEL_EVENT[dvPanel, AUDIO_LOUDSPEAKER_LEVEL]
{
	nVolumeLevelSetIn = LEVEL.VALUE;
}

BUTTON_EVENT[dvPanel, AUDIO_LOUDSPEAKER_LEVEL_PRESS]
{
	RELEASE:
	{
		SEND_LEVEL vdvDevice, 1, nVolumeLevelSetIn;
	}
}

// ----- LOUDSPEAKER MUTE

BUTTON_EVENT[dvPanel, AUDIO_LOUDSPEAKER_MUTE]
{
	PUSH:
	{
		PULSE[vdvDevice, 26];
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, AUDIO_LOUDSPEAKER_MUTE] = [vdvDevice, 199];
}

// ----- MIC MUTE

BUTTON_EVENT[dvPanel, AUDIO_MIC_MUTE]
{
	PUSH:
	{
		PULSE[vdvDevice, 401];
	}
}

BUTTON_EVENT[dvPanel, AUDIO_MIC_UNMUTE]
{
	PUSH:
	{
		PULSE[vdvDevice, 402];
	}
}

BUTTON_EVENT[dvPanel, AUDIO_MIC_MUTE_TOGGLE]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		PULSE[vdvDevice, 400];
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, AUDIO_MIC_MUTE] 	=  [vdvDevice, 403];
	[dvPanel, AUDIO_MIC_UNMUTE] = ![vdvDevice, 403];
}

// ----- BLUETOOTH PAIRING

BUTTON_EVENT[dvPanel, AUDIO_BLUETOOTH_PAIR_ON]
{
	PUSH:
	{
		PULSE[vdvDevice, 606];
	}
}

BUTTON_EVENT[dvPanel, AUDIO_BLUETOOTH_PAIR_OFF]
{
	PUSH:
	{
		PULSE[vdvDevice, 607];
	}
}

BUTTON_EVENT[dvPanel, AUDIO_BLUETOOTH_PAIR_TOGGLE]
{
	PUSH:
	{
		PULSE[vdvDevice, 605];
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, AUDIO_BLUETOOTH_PAIR_ON] 	=  [vdvDevice, 608];
	[dvPanel, AUDIO_BLUETOOTH_PAIR_OFF] = ![vdvDevice, 608];
}

// -------------------- MONITORING

// ----- GPI MUTE
/*
TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, MONITOR_GPI_MUTE_STATUS] = ([vdvDevice, 335]);
}
*/

// ----- USB

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, MONITOR_USB_CONNECTION] = ([vdvDevice, 330]);
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, MONITOR_USB_CALL_ACTIVE] = ([vdvDevice, 331]);
}

// ----- BLUETOOTH

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, MONITOR_BLUETOOTH_CONNECTION] = ([vdvDevice, 610]);
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, MONITOR_BLUETOOTH_STREAM] = ([vdvDevice, 611]);
}

// -------------------- CONFIGURATION

// ----- READY

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, CONFIG_READY] = ([vdvDevice, 300]);
}

// ----- REBOOT

BUTTON_EVENT[dvPanel, CONFIG_REBOOT]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		
		SEND_COMMAND vdvDevice,"'REBOOT'";
	}
}

// ----- SETTINGS

/*
BUTTON_EVENT[dvPanel, CONFIG_HDMI_ENABLE]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		
		PULSE[vdvDevice, 305];
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, CONFIG_HDMI_ENABLE] = ([vdvDevice, 308]);
}
*/

CHANNEL_EVENT[vdvDevice, 313]
{
	OFF:
	{
		DISABLE_BLUETOOTH_BUTTONS();
	}
	ON:
	{
		ENABLE_BLUETOOTH_BUTTONS();
	}
}

BUTTON_EVENT[dvPanel, CONFIG_BLUETOOTH_ENABLE]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		
		PULSE[vdvDevice, 310];
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, CONFIG_BLUETOOTH_ENABLE] = ([vdvDevice, 313]);
}

BUTTON_EVENT[dvPanel, CONFIG_BLUETOOTH_BTN_ENABLE]
{
	PUSH:
	{
		TO[BUTTON.INPUT.DEVICE, BUTTON.INPUT.CHANNEL];
		
		PULSE[vdvDevice, 315];
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, CONFIG_BLUETOOTH_BTN_ENABLE] = ([vdvDevice, 318]);
}

// -------------------- DEVICE EVENTS

// ----- STATUS TEXT

DATA_EVENT[vdvDevice]
{
	COMMAND:
	{
		STACK_VAR CHAR sCmd[1024];
		STACK_VAR CHAR sHeader[255];
		STACK_VAR CHAR sValue[255];
		
		sCmd = DATA.TEXT;
		sHeader = DuetParseCmdHeader(sCmd);
		sValue = DuetParseCmdParam(sCmd);
		
		SELECT
		{
			ACTIVE(FIND_STRING(sHeader, "'CAMERAPRESETSAVED'", 1) > 0):	PULSE[dvPanel, MONITOR_DEVICE_CAMERA_PRESET];
			
			ACTIVE(FIND_STRING(sHeader, "'CAMERAPRESET'", 1) > 0):			nCurrentCameraPreset = ATOI(sValue);
			
			ACTIVE(FIND_STRING(sHeader, "'DEBUG'", 1) > 0):							bDebugEnabled = (ATOI(sValue) == 4);
			
			ACTIVE(FIND_STRING(sHeader, "'NAME'", 1) > 0):							SEND_TEXT(MONITOR_DEVICE_NAME, sValue);
			ACTIVE(FIND_STRING(sHeader, "'SERIALNUMBER'", 1) > 0):			SEND_TEXT(MONITOR_DEVICE_SERIAL, sValue);
			ACTIVE(FIND_STRING(sHeader, "'FWVERSION'", 1) > 0):					SEND_TEXT(MONITOR_DEVICE_FW, sValue);
			ACTIVE(FIND_STRING(sHeader, "'CAMERASTATE'", 1) > 0):				SEND_TEXT(MONITOR_DEVICE_CAMERA, sValue);
			
			ACTIVE(FIND_STRING(sHeader, "'BUILDING'", 1) > 0):					SEND_TEXT(MONITOR_LOCATION_BUILDING, sValue);
			ACTIVE(FIND_STRING(sHeader, "'FLOOR'", 1) > 0):							SEND_TEXT(MONITOR_LOCATION_FLOOR, sValue);
			ACTIVE(FIND_STRING(sHeader, "'ROOM'", 1) > 0):							SEND_TEXT(MONITOR_LOCATION_ROOM, sValue);
			
			//ACTIVE(FIND_STRING(sHeader, "'NETWORKSTATE'", 1) > 0):			SEND_TEXT(MONITOR_ETHERNET_STATE, sValue);
			//ACTIVE(FIND_STRING(sHeader, "'NETWORKADDRESS'", 1) > 0):		SEND_TEXT(MONITOR_ETHERNET_IP, sValue);
			//ACTIVE(FIND_STRING(sHeader, "'NETWORKMAC'", 1) > 0):				SEND_TEXT(MONITOR_ETHERNET_MAC, sValue);
			
			ACTIVE(FIND_STRING(sHeader, "'WIFISTATE'", 1) > 0):					SEND_TEXT(MONITOR_WIFI_STATE, sValue);
			ACTIVE(FIND_STRING(sHeader, "'WIFIADDRESS'", 1) > 0):				SEND_TEXT(MONITOR_WIFI_IP, sValue);
			ACTIVE(FIND_STRING(sHeader, "'WIFIMAC'", 1) > 0):						SEND_TEXT(MONITOR_WIFI_MAC, sValue);
		}
	}
}

DATA_EVENT[dvPanel]
{
    OFFLINE:
    {
    }
    ONLINE:
    {
			REFRESH_ALL();
    }
}

// ----- LOUDSPEAKER LEVEL

LEVEL_EVENT[vdvDevice, 1]
{
	nVolumeLevelCurrentVal = LEVEL.VALUE;
	REFRESH_VOLUME();
}

// ----- CAMERA PTZ

LEVEL_EVENT[vdvDevice, 27]
{
	nPanLevelCurrentVal = LEVEL.VALUE;
	REFRESH_PAN();
}

LEVEL_EVENT[vdvDevice, 28]
{
	nTiltLevelCurrentVal = LEVEL.VALUE;
	REFRESH_TILT();
}

LEVEL_EVENT[vdvDevice, 15]
{
	nZoomLevelCurrentVal = LEVEL.VALUE;
	REFRESH_ZOOM();
}


DEFINE_PROGRAM
